--**                  XX-bit to Hi-/TrueColor convertion routines                       **--
--** The RGB-to-HiColor convertion formulas were "borrowed" from Pete Eberlein's Neil.e **--


function flip(sequence s)
sequence s2
 s2=s
 for i=1 to length(s) do
  s2[length(s)-(i-1)]=s[i]
 end for
 return s2
end function

procedure poke_word(atom dest,object word)
 if sequence(word) then
  for i=1 to length(word) do
   poke(dest+((i-1)*2),and_bits(word[i],#00FF))
   poke(dest+((i-1)*2)+1,floor(and_bits(word[i],#FF00)/256))
  end for
 else
  poke(dest,and_bits(word,#00FF))
  poke(dest+1,floor(and_bits(word,#FF00)/256))
 end if
end procedure

global function makecol15(sequence rgb)
integer col
 col=floor(rgb[3]/8)+and_bits(rgb[2]*4,#E0)
 col=col+((floor(rgb[2]/64)+and_bits(rgb[1]/2,#7C))*256)
 return col
end function


global function makecol16(sequence rgb)
integer col
 col=floor(rgb[3]/8)+and_bits(rgb[2]*8,#E0)
 col=col+((floor(rgb[2]/32)+and_bits(rgb[1],#F8))*256)
 return col
end function

global function makecol24(sequence rgb)
integer col
 col=rgb[3]+(rgb[2]*256)+(rgb[1]*65536)
 return col
end function

global function makecol(integer bpp,sequence rgb)
 if bpp=15 then
  return makecol15(rgb)
 elsif bpp=16 then
  return makecol16(rgb)
 elsif bpp=24 then
  return makecol24(rgb)
 end if
end function

global function convert_image(sequence img,integer dest_bpp,integer source_bpp)
atom mem
integer r,g,b
if dest_bpp=16 then
 mem=allocate(img[2]*img[3]*2)
 if mem=0 then
  return {-1}&img
 end if
 if source_bpp=24 then
  for i=1 to img[3] do
   for j=1 to img[2] do
    poke_word(mem+((i-1)*img[2]*2)+((j-1)*2),makecol16(flip(peek({img[1]+((i-1)*img[2]*3)+((j-1)*3),3}))))
   end for
  end for
  free(img[1])
 elsif source_bpp=8 then	--img[4] must be a palette
  for i=1 to img[3] do
   for j=1 to img[2] do
    poke_word(mem+((i-1)*img[2]*2)+((j-1)*2),makecol16(img[4][peek(img[1]+((i-1)*img[2])+(j-1))+1]))
   end for
  end for
 end if
elsif dest_bpp=15 then
 mem=allocate(img[2]*img[3]*2)
 if mem=0 then
  return {-1}&img
 end if
 if source_bpp=24 then
  for i=1 to img[3] do
   for j=1 to img[2] do
    poke_word(mem+((i-1)*img[2]*2)+((j-1)*2),makecol15(flip(peek({img[1]+((i-1)*img[2]*3)+((j-1)*3),3}))))
   end for
  end for
  free(img[1])
 elsif source_bpp=8 then	--img[4] must be a palette
  for i=1 to img[3] do
   for j=1 to img[2] do
    poke_word(mem+((i-1)*img[2]*2)+((j-1)*2),makecol15(img[4][peek(img[1]+((i-1)*img[2])+(j-1))+1]))
   end for
  end for
 elsif source_bpp=16 then
  for i=1 to img[3] do
   for j=1 to img[2] do
    b=peek(img[1]+((i-1)*img[2]*2)+((j-1)*2))
    b=b+(peek(img[1]+((i-1)*img[2]*2)+((j-1)*2)+1)*256)
    r=floor(and_bits(b,#F800)/2048)
    g=floor(and_bits(b,#07E0)/32)
    b=and_bits(b,#001F)
    poke_word(mem+((i-1)*img[2]*2)+((j-1)*2),b+(floor(g*(31/63))*32)+(r*1024))
   end for
  end for
 end if
elsif dest_bpp=24 then
 mem=allocate(img[2]*img[3]*3)
 if mem=0 then
  return {-1}&img
 end if
 if source_bpp=8 then
  for i=1 to img[3] do
   for j=1 to img[2] do
    poke(mem+((i-1)*img[2]*3)+((j-1)*3),img[4][peek(img[1]+((i-1)*img[2])+(j-1))+1][3])
    poke(mem+((i-1)*img[2]*3)+((j-1)*3)+1,img[4][peek(img[1]+((i-1)*img[2])+(j-1))+1][2])
    poke(mem+((i-1)*img[2]*3)+((j-1)*3)+2,img[4][peek(img[1]+((i-1)*img[2])+(j-1))+1][1])
   end for
  end for  
 elsif source_bpp=16 then
  for i=1 to img[3] do
   for j=1 to img[2] do
    b=peek(img[1]+((i-1)*img[2]*2)+((j-1)*2))
    b=b+(peek(img[1]+((i-1)*img[2]*2)+((j-1)*2)+1)*256)
    r=floor(and_bits(b,#F800)/2048)
    g=floor(and_bits(b,#07E0)/32)
    b=and_bits(b,#001F)
    poke(mem+((i-1)*img[2]*3)+((j-1)*3),floor(b*(255/31)))
    poke(mem+((i-1)*img[2]*3)+((j-1)*3)+1,floor(g*(255/63)))
    poke(mem+((i-1)*img[2]*3)+((j-1)*3)+2,floor(r*(255/31)))
   end for
  end for
 end if
else
 return {-1}&img
end if
return {mem,img[2],img[3]}
end function

