-- tunnel.ex
-- wormhole effect
-- Pete Eberlein <xseal@harborside.com>
-- Mar 1, 1999

-- Modified by Mic, Dec 1999
-- stabmaster_@hotmail.com

without type_check
without warning

include vesa20.e
include asm.e
include bmp.e
include colors.e
include graphics.e
include ports.e

object junk
atom pic1,pic2


puts(1,"Wormhole effect by Pete Eberlein, Mar 1999.\n")
puts(1,"Modified version by Mic, Dec 1999.\n\n")
puts(1,"You can control what will be shown on the screen by using the keyboard.\nThe keys are:\n")
puts(1," [1] Wormhole #1\n [2] Wormhole #2\n [3] Wormhole #1 & #2 mixed together\n")
puts(1," [Esc] Exits the program\n\n")
puts(1,"Press any key to get this thing going..\n")
while get_key()=-1 do
end while
clear_screen()

puts(1,"Loading & converting images...\n")
junk = load_bmp("o024.bmp")		--\
junk=convert_image(junk[2..4],16,24)	-- \
pic1=junk[1]				--  \
					--   | load images
junk = load_bmp("o024_2.bmp")		--  /
junk=convert_image(junk[2..4],16,24)	-- /
pic2=junk[1]				--/



if vesa_mode(320,200,16) then
 puts(2,"Doh! Unable to set graphics mode!\n")
 puts(2,"Possible reasons:\n * No VESA driver installed.\n * Your videocard sucks..\n")
 free(pic1)
 free(pic2)
 abort(1)
end if


constant source=allocate(4), dest=allocate(4)
constant table=allocate(128000)
constant vscreen=allocate(320*200*2),
         vscreen2=allocate(320*200*2) 



integer fn
fn = open("tunnel.dat","rb")
if fn=-1 then
 if graphics_mode(-1) then end if
 puts(2,"Doh! Unable open datafile (tunnel.dat)!\n")
 free(pic1)
 free(pic2)
 abort(1)
end if
junk = repeat(0,128000)
for i = 1 to 128000 do
    junk[i] = getc(fn)    
end for
close(fn)
poke(table, junk)
junk = 0



constant tunnel=get_asm(
"pusha cld "&
"mov edi,[dest] "&
"mov edx,[src] "&
"mov esi,table "&
"mov ebp,pos "&
"mov ecx,32000 "&
"label1: "&
"push ecx "&
"lodsd "&		--get data from table
"mov ebx,eax "&
"and eax,65535 "&	
"shr ebx,16 "&
"add eax,ebp "&
"add ebx,ebp "&
"cmp eax,64000 "&	--..to avoid overflow
"jl label2 "&
"sub eax,64000 "&
"label2: "&
"cmp ebx,64000 "&
"jl label3 "&
"sub ebx,64000 "&
"label3: "&
"sal eax,1 sal ebx,1 "&	--multiply both coordinates by 2	
"mov ecx,eax "&
"mov ax,[edx+ebx] "&	--get pixel #1
"shl eax,16 "&		--keep pixel #1 in eax's high word
"mov ax,[edx+ecx] "&	--get pixel #2
"stosd "&		--write pixels
"pop ecx "&
"dec ecx "&
"jnz label1 "&
"popa ret")
resolve_param("dest",dest)
resolve_param("src",source)
resolve_param("table",table)
constant tunnel_pos=tunnel+get_param("pos")


constant mix=get_asm(
"pusha cld "&
"mov esi,mix_src "&
"mov edi,mix_dest "&
"mov edx,200 "&
"mix_yloop: "&
"mov ecx,320 "&
"mix_xloop: "&
"lodsw "&		--get pixel from screen #1
"mov bx,[edi] "&	--get pixel from screen #2
"shr ax,1 "&		--divide pixels by 2
"shr bx,1 "&		--...
"and ax,31727 "&  	--32727 = 0111101111101111b 
"and bx,31727 "&	--remove higher-most bits of RGB values
"add ax,bx "&		--add pixels
"stosw "&		--write pixel
"loop mix_xloop "&
"dec edx "&
"jnz mix_yloop "&
"popa ret")
resolve_param("mix_src",vscreen2)
resolve_param("mix_dest",vscreen)





atom t1,t2,frames
integer i,i2,di,di2
integer do_mix,key
atom active_screen

active_screen=vscreen
frames=0
i=0
i2=0
di=321
di2=321
key=0
do_mix=0
t1=time()
while key!=27 do
    key=get_key()
    if key='1' then
     active_screen=vscreen
     do_mix=0
    end if
    if key='2' then
     active_screen=vscreen2
     do_mix=0
    end if
    if key='3' then
     active_screen=vscreen
     do_mix=1
    end if
    i+=di				--"rotation speed" for tunnel #1
    i2+=di2				--dito for tunnel #2
    if i>=64000 then i-=64000 end if
    if i2>=64000 then i2-=64000 end if
    poke4(tunnel_pos,i)
    poke4(source,pic1)
    poke4(dest,vscreen)
    call(tunnel)
    poke4(source,pic2)
    poke4(tunnel_pos,i2)
    poke4(dest,vscreen2)
    call(tunnel)
    if do_mix then
     call(mix)
    end if
    while and_bits(Input(#3DA),8) do		--\
    end while					-- | wait for vertical retrace
    while (and_bits(Input(#3DA),8)=0) do	-- |
    end while 					--/	
    single_copy(screen_copy, {active_screen, video_mem, 320*2,200, 320*2, bytes_per_line})
    frames+=1        
    if rand(127)=1 then di=rand(7)+315 end if	--|
    if rand(127)=1 then di2=rand(7)+315 end if	--| randomize movement of wormholes
end while

t2=time()
t2-=t1
if t2=0 then t2=0.01 end if

junk=graphics_mode(-1)
free(table)
free(source)
free(vscreen)
free(vscreen2)
printf(1,"~%d fps\n",floor(frames/t2))

